#!/usr/bin/perl
#  Copyright 2001-2013 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Update' => 'Update',
	   'Edit' => 'Edit',
	   'Attendance' => 'Attendance',
	   'Student' => 'Student',
	   'Date' => 'Date',
	   'Reason' => 'Reason',
	   'Record(s) Updated' => 'Record(s) Updated',
	   'Contact' => 'Contact',
	   'Another' => 'Another',
	   'Today' => 'Today',
	   'Yesterday' => 'Yesterday',
	   'All' => 'All',
	   'Period' => 'Period',
	   'Subject-Section' => 'Subject-Section',
	   'min' => 'min',
	   'Late' => 'Late',
	   'Main' => 'Main',
	   'Error' => 'Error',
	   'Delete' => 'Delete',

	   );

my $self = 'atted.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@<br>\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

my $sth = $dbh->prepare("select * from attend where attid = ?"); 
$sth->execute( $arr{id} );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my ($attid, $studnum, $absdate, $reason, $period, $subjsec, $late) = $sth->fetchrow;


# Print Page Head.
my $title = "$lex{Edit} $lex{Attendance}";
print qq{$doctype\n<html><head><title>$title</title>
<link rel="stylesheet" href="$css" type="text/css">
$chartype\n</head><body style="padding:1em;">\n};

print "[ <a href=\"$homepage\">$lex{Main}</a> | \n";
print "<a href=\"$attpage\">$lex{Attendance}</a> ]\n";

print "<h1>$title</h1>\n";


if ( $arr{page} ) {
    delete $arr{page};
    updateRecord();
}


# Print Form Header
print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"attid\" value=\"$attid\">
<input type=\"hidden\" name=\"page\" value=\"1\">\n";

# Get Student Name
$sth = $dbh->prepare("select lastname, firstname, grade from studentall where studnum = ?");
$sth->execute( $studnum  );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname, $grade ) = $sth->fetchrow;

my $ppd = $g_ppd{$grade};
if ( not $ppd ) { print "<h3>$lex{Error}: Periods per Day not defined for $lex{Grade} $grade</h3>\n"; }

# Name and Student Number
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
print "<tr><td class=\"bra\">$lex{Student}</td>\n";
print "<td>$firstname $lastname ($studnum)</td></tr>\n";

# Date
print "<tr><td class=\"bra\">$lex{Date}</td>\n";
print "<td class=\"la\"><input type=\"text\" Name=\"absdate\" size=\"12\" value=\"$absdate\"></td></tr>\n";

# Reason
print "<tr><td class=\"bra\">$lex{Reason}</td><td class=\"la\">";
print "<select name=\"reason\"><option>$reason</option>\n";
foreach my $reason ( @attend ) {  print "<option>$reason</option>\n"; }
print "</select></td></tr>\n";

# Period
print qq{<tr><td class=\"bra\">$lex{Period}</td>\n};
print qq{<td class=\"la\"><select name="period"><option>$period</option>};
for my $p (1..$ppd) { print "<option>$p</option>"; }
print "</select></td></tr>\n";

# Subjsec
print "<tr><td class=\"bra\">$lex{'Subject-Section'}</td>\n<td class=\"la\">";
print "<input type=\"text\" Name=\"subjsec\" size=\"12\" maxlength=\"32\" value=\"$subjsec\"></td></tr>\n";

# Late
print "<tr><td class=\"bra\">$lex{Late} ($lex{min})</td>\n<td class=\"la\">";
print "<input type=\"text\" Name=\"late\" size=\"4\" value=\"$late\"></td></tr>\n";

print "</table><p><input type=\"submit\" value=\"$lex{Update}\">\n";
print "</form></body></html>\n";



#---------------
sub updateRecord {
#---------------

    my $sth = $dbh->prepare("update attend set
      absdate = ?, reason = ?, period = ?, 
      subjsec = ?, late = ?  where attid = ?");


    if ( not $arr{late} ) { $arr{late} = undef; }
    if ( not $arr{subjsec} ) { $arr{subjsec} = undef; }


    $sth->execute( $arr{absdate}, $arr{reason}, $arr{period} ,
		   $arr{subjsec}, $arr{late}, $arr{attid} );


    if ( not $DBI::errstr ) {
	print "<h3>$lex{'Record(s) Updated'}</h3>";

    } else {
	print "<h3>$lex{Error}: $DBI::errstr<br>\n";
	print "$lex{Contact} $adminname ";
	print "<a href=\"mailto:$adminemail\">$adminemail</a></h3>\n ";

    }

    print "<p>[ <a href=\"$attpage\">$lex{Attendance}</a> ]</p>\n";

    # Another Form
    print "<p><form action=\"attdeled.pl\" method=\"post\">\n";
    print "<select name=\"date\"><option>$lex{Today}</option>\n";
    print "<option>$lex{Yesterday}</option><option>$lex{All}</option></select>\n";
    print "<input type=\"submit\" value=\"";
    print "$lex{Edit}/$lex{Delete} $lex{Another}\"></form></p>\n";

    print "</center></body></html>\n";

    exit;

}
