#!/usr/bin/perl
#  Copyright 2001-2016 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ( 'Edit' => 'Edit',
	    'Transfers' => 'Transfers',
	    'Main' => 'Main',
	    'Last Name' => 'Last Name',
	    'First Name' => 'First Name',
	    'Middle Name' => 'Middle Name',
	    'Birthdate' => 'Birthdate',
	    'Update Record' => 'Update Record',
	    'Another' => 'Another',
	    'Record' => 'Record',
	    'Updated' => 'Updated',
	    'Contact' => 'Contact',
	    'Error' => 'Error',
	    'Student Number' => 'Student Number',
	    'Date' => 'Date',
	    'Type' => 'Type',
	    'Entry Type' => 'Entry Type',
	    'Exit Type' => 'Exit Type',
	    'Province' => 'Province',
	    'Country' => 'Country',
	    'Description' => 'Description',
	    'Identity Number' => 'Identity Number',

	   );

my $self = 'transed.pl';

use CGI;
use DBI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

# pull in global enrol/withdraw descriptors
eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

# Load audit write function
eval require "../../lib/libaudit.pl";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Print Page Head
my $title = "$lex{Edit} $lex{Transfers}";
print "$doctype\n<html><head><title>$title</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">$lex{Main}</a> ]\n";

print "<h1>$title</h1>\n";

if ( $arr{page} ) {
    delete $arr{page};
    updateRecord();
}


my $sth = $dbh->prepare("select * from transfer where id = ?"); 
$sth->execute( $arr{id} );
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr;}
my $ref = $sth->fetchrow_hashref;


print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$arr{id}\">\n";

print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

print "<tr><td class=\"bra\">". $lex{'Student Number'};
print "</td><td><input type=\"text\" name=\"studnum\" size=\"8\" value=\"$ref->{studnum}\" ";
print "maxlength=\"40\"></td></tr>\n";

print "<tr><td class=\"bra\">". $lex{'Last Name'}. "</td>\n<td>";
print "<input type=\"text\" name=\"lastname\" size=\"20\" value=\"$ref->{lastname}\" ";
print "maxlength=\"40\"></td></tr>\n";

print "<tr><td class=\"bra\">". $lex{'First Name'}. "</td>\n<td>";
print "<input type=\"text\" name=\"firstname\" size=\"20\" value=\"$ref->{firstname}\" ";
print "maxlength=\"40\"></td></tr>\n";

print "<tr><td class=\"bra\">". $lex{'Middle Name'}. "</td>\n<td>";
print "<input type=\"text\" name=\"middlename\" size=\"20\" value=\"$ref->{middlename}\" ";
print "maxlength=\"40\"></td></tr>\n";

print "<tr><td class=\"bra\">". $lex{Birthdate}. "</td>\n<td>";
print "<input type=\"text\" name=\"birthdate\" size=\"12\" value=\"$ref->{birthdate}\">\n";
print "</td></tr>\n";

print "<tr><td class=\"bra\">". $lex{'Identity Number'}. "</td>\n<td>";
print "<input type=\"text\" name=\"provnum\" size=\"11\" value=\"$ref->{provnum}\"></td></tr>\n";

print "<tr><td class=\"bra\">$lex{Date}</td>\n<td>";
print "<input type=\"text\" name=\"date\" size=\"11\" value=\"$ref->{date}\" ";
print "maxlength=\"11\"></td></tr>\n";

print "<tr><td class=\"bra\">$lex{Type}</td>\n";
print "<td>$ref->{type}</td></tr>\n";

#print "<select name=\"type\"><option>$ref->{type}</option>\n";
#foreach my $t qw(enrol withdraw) {
#    if ( $t eq $ref->{type} ) { next; }
#    print "<option>$t</option>\n";
#}
#print "</select></td></tr>\n";


print "<tr><td class=\"bra\">$lex{'Entry Type'}</td>\n<td>";
print "<select name=\"entrytype\"><option value=\"$ref->{entrytype}\">$g_enrol{$ref->{entrytype}} ($ref->{entrytype})</option>\n";
foreach my $key ( sort keys %g_enrol ) { 
    if ( $key eq $ref->{entrytype} ) { next; }
    print "<option value=\"$key\">$g_enrol{$key} ($key)</option>\n"; 
}
print "<option value=\"\"></option></td></tr>\n";


print "<tr><td class=\"bra\">$lex{'Exit Type'}</td>\n<td>";
print "<select name=\"exittype\"><option value=\"$ref->{exittype}\">$g_wdraw{ $ref->{exittype} } ($ref->{exittype})</option>\n";
foreach my $key ( sort keys %g_wdraw ) { 
    if ( $key eq $ref->{exittype} ) { next; }
    print "<option value=\"$key\">$g_wdraw{$key} ($key)</option>\n"; 
}
print "<option value=\"\"></option></td></tr>\n";

print "<tr><td class=\"bra\">". $lex{Province}. "</td>\n<td>";
print "<input type=\"text\" name=\"prov\" size=\"8\" value=\"$ref->{prov}\" ";
print "maxlength=\"8\"></td></tr>\n";

print "<tr><td class=\"bra\">". $lex{Country}. "</td>\n<td>";
print "<input type=\"text\" name=\"country\" size=\"8\" value=\"$ref->{country}\" ";
print "maxlength=\"8\"></td></tr>\n";

print "<tr><td class=\"bra\">". $lex{Description}. "</td>\n<td>";
print "<input type=\"text\" name=\"description\" size=\"60\" value = \"$ref->{description}\" ";
print "maxlength=\"255\"></td></tr>\n";

print "<tr><td></td><td><input type=\"submit\" value=\"". $lex{'Update Record'};
print "\"></td></tr>\n";

print "</table></form></body></html>\n";


#---------------
sub updateRecord {
#---------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $id = $arr{id};
    delete $arr{id};

    # Read original record.
    my $sth1 = $dbh->prepare("select * from transfer where id = ?");    
    $sth1->execute( $id );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $tref = $sth1->fetchrow_hashref;


    # Add Audit record.
    my %audit;
    $audit{userid} = $ENV{REMOTE_USER};
    $audit{ipaddr} = $ENV{REMOTE_ADDR};
    $audit{scriptname} = $self;
    $audit{tablename} = 'transfer';
    $audit{tableid} = $id;
    $audit{startval} = $tref; 
    $audit{endval} = \%arr;

    addAudit( \%audit, $dbh );


    my $sth;
    foreach my $key ( sort keys %arr ) { 
	$sth = $dbh->prepare("update transfer set $key = ? where id = ?");    
	$sth->execute( $arr{$key}, $id );
    }

    if ( not $DBI::errstr ) {
	print "<h3>$lex{Record} $lex{Updated}</h3>\n";
    } else {
	print "<h3>$lex{Error}: $DBI::errstr<br>\n";
	print "$lex{Contact}: $adminname <a href=\"mailto:$adminemail\">$adminemail</a> ]</h3>\n";
    }

    print "<p>[ <a href=\"transview.pl\">$lex{Edit} $lex{Another} $lex{Record}</a> | ";
    print "<a href=\"$homepage\">$lex{Main}</a> ]</p>\n";
    print "</body></html>\n";

    exit;

}
