#!/usr/bin/perl
#  Copyright 2001-2010 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Withdraw' => 'Withdraw',
	   'Student' => 'Student',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Withdrawn' => 'Withdrawn',
	   'Contact' => 'Contact',
	   'Main' => 'Main',
	   'Error' => 'Error',
	   'Last,First/Last/Initials/Studnum' => 'Last,First/Last/Initials/Studnum',
	   'Search' => 'Search',
	   'Name' => 'Name',
	   'Birthdate' => 'Birthdate',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Province' => 'Province',
	   'Country' => 'Country',
	   'Description' => 'Description',
	   'Reason' => 'Reason',
	   'Code' => 'Code',
	   'Transfer' => 'Transfer',
	   'Date' => 'Date',
	   'Yes' => 'Yes',
	   'Delete' => 'Delete',
	   'Insert' => 'Insert',
	   'Cannot open' => 'Cannot open',
	   'Student Number' => 'Student Number',

	   );

use DBI;
use CGI;

my $self = 'withdraw.pl';

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;


# Page Header.
print "$doctype\n<html><head><title>$lex{Withdraw} $lex{Student}</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";

if ( $arr{page} == 2 ) { # calendar popup.
    print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
    print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
    print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";
}

print "$chartype\n</head>\n";
if ( not $arr{page} ) {
    print "<body onload=\"document.forms[0].elements[1].focus()\">\n";
} else {
    print "<body>\n";
}




print "<div>[ <a href=\"$homepage\">$lex{Main}</a> ]</div>\n";
print "<h1>$lex{Withdraw} $lex{Student}</h1>\n";


if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectStudent();

}  elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    confirmWithdraw();

}  elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    withdrawStudent();
}




#----------------
sub showStartPage {
#----------------

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\" ";
    print "style=\"padding:0.5em;border:1px solid gray;\">\n";

    print "<tr><td class=\"ra\">$lex{Student} ($lex{'Last,First/Last/Initials/Studnum'})</td>\n";
    print "<td class=\"la\"><input type=\"text\" name=\"student\" size=\"30\"></td></tr>\n";


    print "<tr><td></td><td class=\"la\"><input type=\"submit\" value=\"$lex{Search}\"></td></tr>\n";
    print "</form>\n";
    print "</body></html>\n";

    exit;

} # end of showStartPage


#----------------
sub selectStudent {
#----------------

    my $student = $arr{student};

    # Setup the Search
    if ($student =~ /\d+/) {  # we have a student number
	$studnum = $student;
	$sth = $dbh->prepare("select lastname, firstname, studnum from student
           where studnum = ?");
	$sth->execute( $studnum );

    } else { # we have words hopefully with a comma
	($lastname,$firstname)  = split /\,/, $student;
	$firstname =~ s/^\s*//;
	$lastname =~ s/^\s*//;
	if ($lastname and $firstname){ # both entered.
	    $sth = $dbh->prepare("select lastname, firstname, studnum 
              from student where lastname = ? and firstname = ?
              order by lastname, firstname");
	    $sth->execute( $lastname, $firstname );
	} elsif ( $lastname and not $firstname ){ # only lastname (no comma)
	    if (length($lastname) == 2){ # search by initials: fi, li.

		$fi = substr($lastname,0,1); 
		$li = substr($lastname,1,1);
		$fi .= '%';
		$li .= '%';
		$sth = $dbh->prepare("select lastname,firstname, studnum from student
                   where lastname $sql{like} ? and firstname $sql{like} ?
                   order by lastname, firstname");
		$sth->execute( $li, $fi );
	    } else {
		$sth = $dbh->prepare("select lastname, firstname, studnum 
                 from student where lastname = ? 
                 order by lastname, firstname");
		$sth->execute( $lastname );
	    }
	} else {
	    $sth = $dbh->prepare("select lastname, firstname, studnum 
              from student order by lastname, firstname");
	}
    } # Last Else

    if ( $DBI::errstr ) { print $lex{Error}. ": $DBI::errstr"; die $DBI::errstr; }
    my $first = 1;

    # print table heading.
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    # Loop through each found student.

    while ( my ( $lastname, $firstname,$studnum ) = $sth->fetchrow ) {

	print "<tr><td>";
	print "<form action=\"$self\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
	print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
	print "<input type=\"submit\" value=\"$lex{Withdraw} $firstname $lastname ($studnum)\">\n";
	print "</form></td></tr>\n";
	$first = 0;

    }

    if ( $first ) { # no students
	print "<tr><td style=\"font-size:120%;font-weight:bold;\">";
	print "$lex{'No Student(s) Found'}</td></tr>\n";
	print "</table></div><p></p>\n";
	showStartPage();
    } else {
	print "</table></center></body></html>\n";
    }

    exit;

} # end of selectStudent


#------------------
sub confirmWithdraw {
#------------------

    # foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $studnum = $arr{studnum};

    # Set current time
    my @tim = localtime(time);
    my $year = @tim[5] + 1900;
    my $month = @tim[4] + 1;
    my $day = @tim[3];
    my $currdate = "$year-$month-$day";

    # Load global codes
    if ( not -e "$globdir/global.conf" ) {
	print "<h3>$lex{'Cannot open'} global.conf file!";
	print "</body></html>\n";
	exit;
    }

    # Read the global enrol/withdraw reasons.
    eval { require "$globdir/global.conf"; };
    if ( $@ ) {
	print "<h3>$lex{'Cannot open'} global.conf:\n $@</h3>\n";
	die $lex{'Cannot open'}. " global.conf: $@\n";
    }

    # Read the student data.
    $sth = $dbh->prepare("select lastname, firstname, birthdate, grade, homeroom
      from student where studnum = ?"); 
    $sth->execute( $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname, $birthdate, $grade, $homeroom ) = $sth->fetchrow;

    print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"0\">\n";
    print "<tr><td class=\"ra\">$lex{Name}</td><td class=\"la\"><b>$firstname $lastname</b></td></tr>\n";
    print "<tr><td class=\"ra\">$lex{'Student Number'}</td><td class=\"la\">$studnum</td></tr>\n";
    print "<tr><td class=\"ra\">$lex{Birthdate}</td><td class=\"la\">$birthdate</td></tr>\n";
    print "<tr><td class=\"ra\">$lex{Grade}</td><td class=\"la\">$grade</td></tr>\n";
    print "<tr><td class=\"ra\">$lex{Homeroom}</td><td class=\"la\">$homeroom</td></tr>\n";

    # Blank row
    # print "<tr><td class=\"ra\">&nbsp;</td><td class=\"la\"></td></tr>\n";

    # Start Form
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";

    # Withdraw Date
    print "<tr><td class=\"ra\">$lex{Withdraw} $lex{Date}</td>\n<td class=\"la\">";
    print "<input type=\"text\" ";
    print "name=\"date\" id=\"date\" size=\"10\" value=\"$currdate\">\n";
    print "<button type=\"reset\" id=\"start_trigger\">...</button>\n";
    print "</td></tr>\n";

    # Withdraw Reason
    print "<tr><td class=\"ra\">$lex{Withdraw} $lex{Reason}</td>\n";
    print "<td class=\"la\"><select name=\"exittype\">\n";
    foreach my $type (sort keys %g_wdraw){
        print "<option value=\"$type\">$g_wdraw{$type}</option>\n";
    }
    print "</select></td></tr>\n";


    print "<tr><td class=\"ra\">$lex{Province} $lex{Code}</td>";
    print "<td class=\"la\"><input type=\"text\" name=\"prov\" size=\"4\">";
    print " $lex{Transfer} -> $lex{Province}</td></tr>\n";

    print "<tr><td class=\"ra\">$lex{Country} $lex{Code}</td>\n";
    print "<td class=\"la\"><input type=\"text\" name=\"country\" size=\"4\">";
    print " $lex{Transfer} -> $lex{Country}</td></tr>\n";

    print "<tr><td class=\"ra\">". $lex{Description}. "</td>\n<td class=\"la\">";
    print "<textarea name=\"description\" rows=\"3\" cols=\"50\"></textarea></td></tr>\n";

    print "<tr><td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"";
    print "$lex{Yes}, $lex{Withdraw} $firstname $lastname\"></td></tr>\n";
    print "</table></form>\n";

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"date\", 
        ifFormat       :    \"%Y-%m-%d\",
        button         :    \"start_trigger\",
        singleClick    :    false,
        step           :    1
    });
    </script>\n";

    print "</body></html>\n";

    exit;
}



#------------------
sub withdrawStudent {
#------------------

    # foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $sth = $dbh->prepare("select * from student where studnum = ?"); 
    $sth->execute( $arr{studnum} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;
    my @student = $sth->fetchrow;

    if ( $rows < 1) { #Error!
	print "<h1>$lex{Error}: $lex{'No Student(s) Found'}!</h1>\n";
	print "</body></html>\n";
	exit;
    }



    # Insert Student Record into WD student table
    $student[0] = $sql{default};  # reset the studid/id.
    foreach my $studfld ( @student ){ 
	if ( $studfld ne $sql{default} ) { $studfld = $dbh->quote( $studfld ); }
    }
    my $studentstr = join(', ', @student);

    $sth = $dbh->prepare("insert into studentwd values ( $studentstr )");
    $sth->execute;

    if ( $DBI::errstr) {
	print "<h3>$lex{Insert} $lex{Student} $lex{Error}:";
	print "$lex{Contact} $adminname ";
	print "[ <a href=\"mailto:$adminemail\">$adminemail</a><br>\n";
	print "$lex{Error}:$DBI::errstr</h3>\n";
	die "$lex{Error}:$self: $DBI::errstr\n";
    }
    print "<h3>$lex{Student} -> $lex{Withdrawn} $lex{Student}</h3>\n";



    # Delete Original Student Record from student table
    $sth = $dbh->prepare("delete from student where studnum = ?"); 
    $sth->execute( $arr{studnum} );

    if ( $DBI::errstr) {
	print "<h3>$lex{Delete} $lex{Student} $lex{Error}:";
	print "$lex{Contact} $adminname ";
	print "[ <a href=\"mailto:$adminemail\">$adminemail</a><br>\n";
	print "$lex{Error}:$DBI::errstr</h3>\n";
	die "$lex{Delete} $lex{Student} $lex{Error}:$self: $DBI::errstr\n";
    }



    # Insert a transfer record.
    # Get student record, now in studentwd
    $sth = $dbh->prepare("select * from studentwd where studnum = ?");
    $sth->execute( $arr{studnum} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $ref = $sth->fetchrow_hashref;
    my %stud = %$ref;

    $sth = $dbh->prepare("insert into transfer 
      ( studnum, date, type, description, exittype, prov, country, 
        lastname, firstname, middlename, birthdate, provnum ) 
      values ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? )");

    $sth->execute( $arr{studnum}, $arr{date}, 'withdraw', $arr{description},
		   $arr{exittype}, $arr{prov}, $arr{country},
		   $stud{lastname}, $stud{firstname}, $stud{initial}, 
		   $stud{birthdate}, $stud{provnum} ); 

    if ($DBI::errstr) {
	print "<h3>$lex{Insert} $lex{Error}:";
	print "$lex{Contact} $adminname ";
	print "[ <a href=\"mailto:$adminemail\">$adminemail</a><br>\n";
	print "$lex{Error}:$DBI::errstr</h3>\n";
	die "$lex{Insert} $lex{Error}:$self: $DBI::errstr\n";
    }


    print "<p>[ <a href=\"$homepage\">$lex{Main}</a> ]</p>\n";
    print "</body></html>\n";

} # end of withdrawStudent
