#! /usr/bin/perl
#  Copyright 2001-2015 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Assume now that the school is passed that will be reporting on.

my %lex = ('Progress Reports' => 'Progress Reports',
	   'Main' => 'Main',
	   'Error' => 'Error',
	   'View/Download/Print Progress Reports' => 'View/Download/Print Progress Reports',
	   'View Log File' => 'View Log File',
	   'Progress Report to Parents' => 'Progress Report to Parents',
	   'Evaluation \\& Comment Key' => 'Evaluation \\& Comment Key',
	   'Objectives' => 'Objectives',
	   'Term' => 'Term',
	   'Comments' => 'Comments',
	   'Additional Comments' => 'Additional Comments',
	   'Teacher' => 'Teacher',
	   'Parent/Guardian Signature' => 'Parent/Guardian Signature',
	   'Principal Signature' => 'Principal Signature',
	   'School' => 'School',
	   'Report' => 'Report',
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'ieprptprogress.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;
my $studnum = $arr{studnum};

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "../../lib/liblatex.pl";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');

    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$tchpage\">$lex{Main}</a> ]\n";
    print "<form action=\"../tlogin.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"iep/$self\">\n";
    print "<input type=\"submit\" value=\"$lex{'Please Log In'}\">\n";
    print "</form></body></html>\n";
    exit;

}

my $userid = $session->param('userid');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from staff where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


# Print Page Heading
my $title = "$lex{Student} $lex{Progress} $lex{Report}";
print "$doctype\n<html><head><title>$title</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head>\n";
print "<body>[ <a href=\"$tchpage\">$lex{Main}</a> ] $firstname $lastname\n";


# Choose Date; set on main HTML page.
if ( $arr{date} ) { # if a date is passed...
    my ( $yr, $mo, $da ) = split /-/, $arr{date};
    $date = "$month[$mo] $da, $yr";
} else { # no date passed, use today.
    $date = $currdate;
}



my $shortname = "repprog$$";
my $filename = "$shortname.tex";

open(TEX,">$filename") || die "Can't open tex file";

my $papersize;
if ( $defaultpapersize ) {
    $papersize = $defaultpapersize;
} else {
    $papersize = 'letterpaper';
}


# Preamble and Head of Document
print TEX <<"EOS1";  
\\documentclass[11pt,$papersize,oneside]{article}
\\usepackage{array,graphicx,multicol,colortbl,inputenc}
\\inputencoding{latin1}
\\renewcommand{\\familydefault}{\\sfdefault}

\\setlength{\\hoffset}{-0.3in}
\\setlength{\\voffset}{-0.5in}
\\setlength{\\headsep}{10pt}
\\setlength{\\headheight}{14pt}
\\setlength{\\topmargin}{0in}
\\setlength{\\textwidth}{7.2in}
\\setlength{\\textheight}{9.5in}
\\setlength{\\parindent}{0pt}
\\setlength{\\evensidemargin}{0in}
\\setlength{\\oddsidemargin}{0in}
\\setlength{\\extrarowheight}{4pt}
\\pagestyle{headings}

\\begin{document}
EOS1

$sort = "order by s.lastname, s.firstname";

# Find students in evalmst;
$sth = $dbh->prepare("select distinct e.studnum from iep_evalmst as e, iep_student as s
  where e.studnum = s.studnum $select $sort");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

my $sth1 = $dbh->prepare("select * from iep_student where studnum = ?");
my $sth2 = $dbh->prepare("select * from iep_evalmst where studnum = ?");
my $sth3 = $dbh->prepare("select * from iep_objectives where catnum = ?");

while ( my $studnum = $sth->fetchrow ) {

    # Find the student info from iep_student;
    $sth1->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $sref = $sth1->fetchrow_hashref;
    my %r = %$sref;
    my $studname = "$r{firstname} $r{lastname}";


    # Print the heading section for each new report card
    print TEX "\\thispagestyle{empty}\n\\begin{center}\\vspace*{1.5in}\n\n";
    print TEX "{\\sf\\huge ". $lex{'Progress Report to Parents'}. "}\n\n";
    print TEX "\\smallskip\n{\\sf\\Large $divisionname}\n\n";
    print TEX "\\bigskip\n{\\sf\\Huge\\it $studname}\n\n";
    print TEX "\\bigskip\n{\\sf $date}\n\\end{center}\n\\newpage\n";

    print TEX "\\setcounter{page}{1}\n";
    print TEX "\\markright{$schoolname -- $schoolyear \\hfill  $studname -- }\n";

    print TEX "\\begin{center}\n\\medskip\n{\\sf\\huge ". $lex{'Progress Report to Parents'};
    print TEX "}\\\\ \n \\smallskip \n {\\sf\\Large $divisionname}\n\n\\bigskip\n";
    print TEX "{\\sf\\LARGE\\it $studname}\n\\medskip\n";

    print TEX "\\setlength{\\extrarowheight}{4pt}\n\n\\hrulefill \n\n\\smallskip\n";

#    print TEX "{\\sf\\Large ". $lex{'Evaluation \\& Comment Key'}. "}\n\n\\medskip\n";
#    print TEX "\\begin{center}\n\\parbox{4in}{\n";
#    foreach $evalkey ( @g_eval ){  # values from ppp.conf 
#	print TEX "$evalkey \\\\ \n";
#    }

#    print TEX "}\\end{center}\n\n";
    # End of heading section for each new report card.


    # Loop; once for each subject.



    # Find their objectives (iep_evalmst);
    $sth2->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
SUBJECT: 

    while ( my @evalmst = $sth2->fetchrow ) {

	@evalmst = latex_filter( @evalmst );
	my $subnum = $evalmst[2];

	#lookup subject name
	$sth3->execute( $subnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my @catsubject = $sth3->fetchrow; 
	@catsubject = latex_filter( @catsubject );

	my $subname = $catsubject[2];
	#print "SN: $studnum  SUB: $subname $subnum<br>\n";

	# Now find all term records for this subject for this student.
	$sth4 = $dbh->prepare("select * from iep_eval where studnum = ? and 
          subnum = ? order by term");
	$sth4->execute( $studnum, $subnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my $termrows = $sth4->rows;
	if ($termrows < 1){ next SUBJECT;} # no eval records... skip.

	# print "TR: $termrows  SN:$studnum<br>\n";

	# Loop through all terms, pushing evaluations into anonymous arrays.   
	for (my $j=1; $j<=$termrows;$j++){
	    @termeval = $sth4->fetchrow;
	    @termeval = latex_filter( @termeval );
	    #print "TRM: @termeval<br>\n";
	    $master[$j] = [@termeval];
	}
	# Last value of @termeval is current term, since they're sorted.
	#  Check that this term has "something"; if not, skip this subject.
	my $subjflag = 0;
	for ($j=3; $j<=34;$j++){
	    if ($termeval[$j]){ $subjflag = 1; last;} # value in obj1-32
	}
	if ($termeval[36]){ $subjflag = 1;} # value in comment
	#if (not $subjflag){ 
	#   print "Skipping due to lack of comments...: $studname ";
	#   print "($evalmst[1]) Subject: $evalmst[2]<br>\n";	
	#   next SUBJECT; 
	#}
    

	print TEX "\\begin{tabular}{|p{4in}|";
	for (1..$termrows){
	    print TEX "p{0.6in}|";
	}
	print TEX "}\n\\hline\n";
	# End of first table definition

	print TEX "\\rowcolor[gray]{0.85} \\hfil \\vrule height 16pt depth 6pt width 0pt ";
	print TEX "{\\LARGE\\sf $subname} \\hfil\n";
	for (1..$termrows){
	    print TEX " & ";
	}
	print TEX "\\\\ \\hline\n";


	# Now print the term numbers
	print TEX "\\rowcolor[gray]{0.92}\\hfil{\\bf\\sf ". $lex{Objectives}. "}\\hfil";
	for ( 1..$termrows ) {
	    print TEX "& {\\bf\\sf ". $lex{Term}. " $master[$_]->[35] }";
	}
	print TEX "\\\\ \\hline\n"; # End of Table Header

	# Now print the table
	for my $j ( 3..34 ) {
	    if ($evalmst[$j] and $master[$termrows]->[$j]){ # objective exists and 
		# an evaluation is present for this objective this term.
		$evalmst[$j] =~ s/\([0-9-]*\)//g;
		print TEX "$evalmst[$j]";
		for ($k=1;$k<=$termrows;$k++){
		    print TEX "& \\hfil $master[$k]->[$j] \\hfil\n";
		}
		print TEX "\\\\\\hline\n";
		# This below will allow separation by page.
		if ($j % 3 == 2){  # Do 5,8,11, etc.
		    print TEX "\\end{tabular}\n\\begin{tabular}{|p{4in}|";
		    for ( 1..$termrows ) {
			print TEX "p{0.6in}|";
		    }
		    print TEX "}\n\\hline\n";
		}
	    }
	}
	print TEX "\\end{tabular}\n\n";

	# Calculate width of matching tabular for comments
	$width = 4 + $termrows * 0.6;
	$width = $width."in";
    
	if ( $master[$termrows]->[36] ) {  # If comment exists...
	    print TEX "\\begin{tabular}{p{$width}}\n";
	    # print comments at end of table.
	    for ( my $k=1;$k<=$termrows;$k++ ) {
		print TEX "{\\bf\\sf ". $lex{Term}. " $master[$k]->[35] ";
		print TEX $lex{Comments}. ":} $master[$k]->[36]\\\\ \n";
	    }
	    print TEX "\\end{tabular}\n\n";  
	}
	print TEX "\\bigskip\n\n";
	
    } # End of Subject "For" Loop
    
    print TEX "\\end{center}\n\\newpage\n\n";

    # Room for Additional Comments
    
    print TEX "\\parbox{7in}{{\\bf ". $lex{'Additional Comments'};
    print TEX ": }\n\n\\vspace{1.3in}\n\n";
    print TEX "\\underline{\\hspace{3in}} \\hfill \\underline{\\hspace{3in}} \n\n";
    print TEX $lex{Teacher}. " \\hfill ". $lex{Teacher}. "\\\\ \n }\n";

    print TEX "%\\dotfill \n";
    print TEX "\\bigskip\n\n\\bigskip\n\n";

    # Should have more logic here for printing this... July/08
    if ($term == 1 or $term == 2){
	print TEX "\\underline{\\hspace{3in}}\n\n". $lex{'Parent/Guardian Signature'}. "\n\n";
	print TEX "\\medskip\n\n";
    } else {
	print TEX "\\underline{\\hspace{3in}}\n\n". $lex{'Principal Signature'}. "\n\n";
	print TEX "\\medskip\n\n";
    }

    print TEX "{\\bf Comments:}\n\n\\newpage\n";


} # End of Student Loop


# Print ending of report
print TEX "\\end{document}\n";
close TEX;

print qq{<h2><a href=\"$tchwebdownloaddir/$shortname.pdf\">\n};
print qq{$lex{'View/Download/Print Progress Reports'}</a></h2>\n};
print qq{<p>[ <a href=\"$tchpage\">$lex{Main}</a> | \n};
print qq{<a href="$webdownloaddir/pdflog$$.txt">$lex{'View Log File'}</a> ]</p>\n};

system("$pdflatex $filename > pdflog$$.txt");
system("mv $shortname.pdf $tchdownloaddir");
system("mv pdflog$$.txt $tchdownloaddir");
system("rm -f $shortname.*");

print "</body></html>\n";
