<!DOCTYPE html>
<!--
#  Copyright 2001-2017 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.
-->
<html><head><title>Open Admin - <#Pre-Registration#></title>
<link rel="stylesheet" href="admin.css" type="text/css">
<style type="text/css">
  form, input, button, select { padding:0; margin:0;font-size:100%; }
</style>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head><body style="padding:2em 6em;">

<ul class="nav" style="border-top:1px solid black; margin: 0.5em; 
 position: fixed; top:0; bottom:auto;">
<li><a href="index.shtml"><#Main#></a></li>
<li><a href="attendance.html"><#Attendance#></a></li>
<li><a href="discipline.html"><#Discipline#></a></li>
<li><a href="fees.html"><#Fees#></a></li>
<li><a href="repcard.html"><#Report Cards#></a></li>
<li><a href="timetable.html"><#Timetable#></a></li>
<li><a href="export.html"><#Export/Xfer#></a></li>
<li><a href="eoy.html"><#Start/End of Year#></a></li>
<li><a href="ssp.html"><#SSP#></a></li>
</ul>


<h2><#Pre-Registration#></h2>

<div style="width:80em;">
New students registering in Kindergarten before current year end can
be preregistered using the normal method for entering new students
(enter a blank student number in the Enter/Withdraw student item.),
but instead select the box for &quot;preregistration&quot;. This will
place this student's record in a preregistration table. These records
can be added to the other student records later.

<div style="margin:0.5em;">
<form action="/cgi-bin/prereg/prstudview.pl" method="post" style="display:inline;">
<input type="submit" value="<#View Pre-registration Table#>"></form>
</div></div>



<h3>Reporting for the Next School Year</h3>


<div style="width:80em;">In order to provide a year end report to teachers of
their next years students, here is an overview of the steps:

<ol style="margin-top:0.5em;">
<li>Copy the teacher and student grade/homeroom data to temporary tables.</li>

<li>Update the copied teacher table for next year's homeroom assignment.</li>

<li>Promote students in copied student data table to the next
grade.</li>

<li>Assign homerooms to the copied student data table.</li>

<li>Print reports based on this information.</li>

<li>The information in these two temporary tables can then be used to
  automatically update the permanent teacher and student tables, once
  the new school year starts (August). <b>Do Not</b> update your
  records at the end of June, since yearly backups are done in
  Mid-July
</ol>
</div>
<p>&nbsp;</p>



<div>The <b>procedures</b> for this process follow:

<div style="width:80em;">
<ol style="margin-top:0.5em;">
<li>Make sure all pre-registrations are entered, if any</li>

<li>Copy the current staff table into a temporary staff table and
make sure that homeroom assignments are correct.<br>

<form action="/cgi-bin/prereg/copystaff.pl" method="post" style="display:inline;">
<input type="submit" value="Copy Staff Records"></form>&nbsp;
to temporary prereg staff table, replacing any existing data.<br>

Update the pre-registration staff table using the following:<br>

<form action="/cgi-bin/staff/staffdeled.pl" method="post" style="display:inline;">
<input type="hidden" name="tbl" value="prereg">
<input type="submit" value="Edit/Delete Prereg Staff"></form>

<form action="/cgi-bin/staff/staffadd.pl" method="post" style="display:inline;">
<input type="hidden" name="tbl" value="prereg">
<input type="submit" value="Add Prereg Staff"></form>
<br>

<form action="/cgi-bin/staff/staffview.pl" method="post" style="display:inline;">
<input type="hidden" name="tbl" value="prereg">
<input type="submit" value="View Prereg Staff"></form>

<form action="/cgi-bin/staff/staffrpt.pl" method="post" style="display:inline;">
<input type="hidden" name="tbl" value="prereg">
<input type="submit" value="Prereg Staff Report"></form>

</li>


<li>Copy current student data into a temporary grade/homeroom
preregistration table. This process also adds the students from
pre-registration table (normally mainly K students).<br>

<form action="/cgi-bin/prereg/promote.pl" method="post" style="display:inline;">
<input type="submit" value="Assign Student Grades"></form>&nbsp;
copy from student/prereg tables and allow promotion of selected
students.</li>

<li><form action="/cgi-bin/prereg/asclass.pl" method="post" style="display:inline;">
<input type="submit" value="Assign Student Homerooms"></form>&nbsp;assign
students in the temporary table a new homeroom.</li>


<li>View/Print reports with new homeroom assignments, etc.<br>

<form action="/cgi-bin/prereg/prstudview1.pl" method="post" style="display:inline;">
<input type="submit" value="View Temporary Student Table Updates"></form>

<form action="/cgi-bin/prereg/premptyclasslist.pl" method="post" style="display:inline;">
<input type="submit" value="View/Print Empty Classlists (PDF)"></form>
</li>

<li>Once year end reports, etc. are done, these records can be used
to update the master records for homeroom, grade in student table, and
the temporary teacher table replaces the current teacher table.

<h3>Do NOT do this until August!</h3>
  
<ul>
<li><form action="/cgi-bin/prereg/copybackstaff.pl" method="post" style="display:inline;">
<input type="submit" value="Copy Back Staff"></form>&nbsp;
This will replace the current staff table data with the
prereg staff data.</li>

<li><form action="/cgi-bin/prereg/prexfer.pl" method="post" style="display:inline;">
<input type="submit" value="Copy Prereg Students to Student Table"></form>

<li><form action="/cgi-bin/prereg/preupdateroom.pl" method="post" style="display:inline;">
<input type="submit" value="Update Homeroom and Grade From Prereg"></form></li>
</ul>

<li>After checking that all registrations are correct:<br>
<form action="/cgi-bin/prereg/preregempty.pl" method="post" style="display:inline;">
<input type="submit" value="Empty Student Preregistration Table"></form>
</li>
</ol>
</div>

</body></html>
