#!/usr/bin/perl

# Add Staff...
use DBI;


my ($password, $dbase) = @ARGV;

if ( not $password ) {
    print "Usage: ./addstaff.pl password dbase\n";
    exit;
}

my $user = 'root';

my @grades = qw(K 1 2 3 4 5 6 7 8 9 );


my $dsn = "DBI:mysql:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
$dbh->{mysql_enable_utf8} = 1;

# Get the teachers
my %teacher; # $teacher{grade}{userid} = 1;

my $sth = $dbh->prepare("select userid, lastname, firstname from staff");
my $sth1 = $dbh->prepare("select field_value from staff_multi where field_name = 'grade' and userid = ?");

$sth->execute;
if ($DBI::errstr){ print "$lex{Error}: $DBI::errstr; $!\n"; die $DBI::errstr; }
while ( my ($userid, $lastname, $firstname ) = $sth->fetchrow ) {

    # Get the grade,
    $sth1->execute($userid);
    if ($DBI::errstr){ print "$lex{Error}: $DBI::errstr; $!\n"; die $DBI::errstr; }
    my $grade = $sth1->fetchrow;

    # Add to teacher hash
    $teacher{$grade}{$userid} = qq{$lastname, $firstname};
}




my $sth = $dbh->prepare("insert into subject ( subjcode, description, grade, teacher, section, subjsec, startrptperiod, endrptperiod )
 values( ?, ?, ?, ?, ?, ?, ?, ?)");

my $sth1 = $dbh->prepare("select * from sasked_courses where grade = ? order by code");


foreach my $grade ( @grades ) { # do grades 1 to 9

    my %t = %{ $teacher{$grade}};

    $sth1->execute($grade);
    if ($DBI::errstr){ print "$lex{Error}: $DBI::errstr; $!\n"; die $DBI::errstr; }

    # get 6 courses for this grade in order
    my %sasked;
    foreach my $count (1..6 ) {
	my $ref = $sth1->fetchrow_hashref;
	my %r = %$ref;  # we now have the course from sasked_courses.
	if ( $r{code} ) {
	    print "Grade:$grade - $r{title}\n";
	    $sasked{$r{code}} = $r{title};
	}
    }

    
    foreach my $userid ( keys %t ) {

	foreach my $code ( keys %sasked ) {

	    my $title = $sasked{$code};
	    my $subjsec = "$code-1";

	    $sth->execute( $code, $title, $grade, $userid, '1', $subjsec, '1','3');
	    if ($DBI::errstr){ print "$lex{Error}: $DBI::errstr; $!\n"; die $DBI::errstr; }	    

	} # code loop (6)
    } # end of userid loop
	    
} # end of grade loop


print "Done!\n";
